// ****************************************************************************
//
//          Aevol - An in silico experimental evolution platform
//
// ****************************************************************************
//
// Copyright: See the AUTHORS file provided with the package or <www.aevol.fr>
// Web: http://www.aevol.fr/
// E-mail: See <http://www.aevol.fr/contact/>
// Original Authors : Guillaume Beslon, Carole Knibbe, David Parsons
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************

#ifndef AEVOL_PHENOTYPIC_TARGET_CONSTITUENT_H_
#define AEVOL_PHENOTYPIC_TARGET_CONSTITUENT_H_

#include <iostream>
#include <memory>

namespace aevol {

class PhenotypicTargetConstituent {
 public:
  PhenotypicTargetConstituent() = default;
  PhenotypicTargetConstituent(double height, double mean, double width): height_{height}, mean_{mean}, width_{width} {}
  PhenotypicTargetConstituent(const PhenotypicTargetConstituent& model) = default;
  virtual ~PhenotypicTargetConstituent() {}

  static auto make_from_checkpoint(std::istream& is) -> std::unique_ptr<PhenotypicTargetConstituent>;
  virtual auto make_copy() const -> std::unique_ptr<PhenotypicTargetConstituent> = 0;

  virtual auto keywd() const -> std::string = 0;

  double height() const { return height_; }
  double mean() const { return mean_; }
  double width() const { return width_; }
  void set_height(double height) { height_ = height; }
  void set_mean(double mean) { mean_ = mean; }

  virtual auto compute_y(double x) const -> double = 0;

 protected:
  double height_;
  double mean_;
  double width_;  // In fact half-width
};

}  // namespace aevol

#endif  // AEVOL_PHENOTYPIC_TARGET_CONSTITUENT_H_
